<template>
  <div id="container">
    <Loading v-if="isLoading" />
    <AccessRequestListVue
      v-if="!isLoading && accessRequests"
      :access-requests="accessRequests"
    />
    <Error v-if="error.statusCode" :error="error" />
  </div>
</template>

<script>
import AccessRequestListVue from '~/components/AccessRequestList.vue';
import Loading from '~/components/Loading.vue';
import Error from '~/components/Error.vue';

export default {
  components: {
    AccessRequestListVue,
    Loading,
    Error,
  },
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      accessRequests: null,
      isLoading: true,
      error: {},
    };
  },
  async fetch() {
    try {
      this.accessRequests = await this.$nuxt.context.store.dispatch(
        'access_request/fetchMyAccessRequests'
      );
    } catch (e) {
      this.error.statusCode = 403;
      this.loading = false;
    }
  },
  head() {
    return {
      title: 'My Access Requests - RISIS Workspace',
    };
  },
  mounted() {
    this.isLoading = false;
  },
};
</script>

<style scoped>
table {
  width: 100%;
}
</style>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>
